]> git.saurik.com Git - apt.git/blob - test/integration/framework
trusted=yes sources are secure, we just don't know why
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 # we all like colorful messages
6 if [ "$MSGCOLOR" != 'NO' ]; then
7 if [ ! -t 1 ]; then # but check that we output to a terminal
8 export MSGCOLOR='NO'
9 fi
10 fi
11
12
13 if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
24 fi
25
26 msgdie() { printf "${CERROR}E: $1${CNORMAL}\n" >&2; exit 1; }
27 msgwarn() { printf "${CWARNING}W: $1${CNORMAL}\n" >&2; }
28 msgmsg() { printf "${CMSG}$1${CNORMAL}\n"; }
29 msginfo() { printf "${CINFO}I: $1${CNORMAL}\n"; }
30 msgdebug() { printf "${CDEBUG}D: $1${CNORMAL}\n"; }
31 msgdone() { printf "${CDONE}DONE${CNORMAL}\n"; }
32 msgnwarn() { printf "${CWARNING}W: $1${CNORMAL}" >&2; }
33 msgnmsg() { printf "${CMSG}$1${CNORMAL}"; }
34 msgninfo() { printf "${CINFO}I: $1${CNORMAL}"; }
35 msgndebug() { printf "${CDEBUG}D: $1${CNORMAL}"; }
36 msgtest() {
37 while [ -n "$1" ]; do
38 printf "${CINFO}$1${CCMD} "
39 printf -- "$(echo "$2" | sed -e 's#^apt\([cgfs]\)#apt-\1#')${CINFO} "
40 shift
41 if [ -n "$1" ]; then shift; else break; fi
42 done
43 printf "…${CNORMAL} "
44 }
45 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
46 msgskip() { printf "${CWARNING}SKIP${CNORMAL}\n" >&2; }
47 msgfail() {
48 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
49 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
50 if [ -n "$APT_DEBUG_TESTS" ]; then
51 bash
52 fi
53 EXIT_CODE=$((EXIT_CODE+1));
54 }
55
56 # enable / disable Debugging
57 MSGLEVEL=${MSGLEVEL:-3}
58 if [ $MSGLEVEL -le 0 ]; then
59 msgdie() { true; }
60 fi
61 if [ $MSGLEVEL -le 1 ]; then
62 msgwarn() { true; }
63 msgnwarn() { true; }
64 fi
65 if [ $MSGLEVEL -le 2 ]; then
66 msgmsg() { true; }
67 msgnmsg() { true; }
68 msgtest() { true; }
69 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
70 msgskip() { printf " ${CWARNING}S${CNORMAL}" >&2; }
71 if [ -n "$CFAIL" ]; then
72 msgfail() { printf " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
73 else
74 msgfail() { printf " ###FAILED###" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
75 fi
76 fi
77 if [ $MSGLEVEL -le 3 ]; then
78 msginfo() { true; }
79 msgninfo() { true; }
80 fi
81 if [ $MSGLEVEL -le 4 ]; then
82 msgdebug() { true; }
83 msgndebug() { true; }
84 fi
85 msgdone() {
86 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
87 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
88 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
89 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
90 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
91 true;
92 else
93 printf "${CDONE}DONE${CNORMAL}\n";
94 fi
95 }
96 getaptconfig() {
97 if [ -f ./aptconfig.conf ]; then
98 echo "./aptconfig.conf"
99 elif [ -f ../aptconfig.conf ]; then
100 echo "../aptconfig.conf"
101 fi
102 }
103 runapt() {
104 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
105 local CMD="$1"
106 shift
107 case $CMD in
108 sh|aptitude|*/*|command) ;;
109 *) CMD="${BUILDDIRECTORY}/$CMD";;
110 esac
111 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
112 }
113 aptconfig() { runapt apt-config "$@"; }
114 aptcache() { runapt apt-cache "$@"; }
115 aptcdrom() { runapt apt-cdrom "$@"; }
116 aptget() { runapt apt-get "$@"; }
117 aptftparchive() { runapt apt-ftparchive "$@"; }
118 aptkey() { runapt apt-key "$@"; }
119 aptmark() { runapt apt-mark "$@"; }
120 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
121 apt() { runapt apt "$@"; }
122 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
123 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
124 aptitude() { runapt aptitude "$@"; }
125 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
126 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
127
128 dpkg() {
129 command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@"
130 }
131 dpkgcheckbuilddeps() {
132 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
133 }
134 gdb() {
135 local CMD="$1"
136 shift
137 runapt command gdb --quiet -ex run "${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
138 }
139
140 exitwithstatus() {
141 # error if we about to overflow, but ...
142 # "255 failures ought to be enough for everybody"
143 if [ $EXIT_CODE -gt 255 ]; then
144 msgdie "Total failure count $EXIT_CODE too big"
145 fi
146 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
147 }
148
149 shellsetedetector() {
150 local exit_status=$?
151 if [ "$exit_status" != '0' ]; then
152 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
153 if [ "$EXIT_CODE" = '0' ]; then
154 EXIT_CODE="$exit_status"
155 fi
156 fi
157 }
158
159 addtrap() {
160 if [ "$1" = 'prefix' ]; then
161 CURRENTTRAP="$2 $CURRENTTRAP"
162 else
163 CURRENTTRAP="$CURRENTTRAP $1"
164 fi
165 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
166 }
167
168 setupenvironment() {
169 TMPWORKINGDIRECTORY=$(mktemp -d)
170 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
171 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
172
173 TESTDIRECTORY=$(readlink -f $(dirname $0))
174 # allow overriding the default BUILDDIR location
175 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
176 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
177 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
178 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
179 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
180 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
181 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
182 # -----
183
184 cd $TMPWORKINGDIRECTORY
185 mkdir rootdir aptarchive keys
186 cd rootdir
187 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
188 mkdir -p var/cache var/lib/apt var/log tmp
189 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
190 touch var/lib/dpkg/available
191 mkdir -p usr/lib/apt
192 ln -s ${METHODSDIR} usr/lib/apt/methods
193 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
194 mkdir -p usr/lib/apt/solvers
195 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
196 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
197 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
198 fi
199 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
200 # system
201 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
202 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
203 else
204 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
205 fi
206 cd ..
207 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
208 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
209 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
210 fi
211 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
212 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
213 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
214 fi
215 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
216 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
217 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
218
219 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
220 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
221 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
222 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
223 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
224 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
225 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
226 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
227 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
228 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
229 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
230 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
231 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
232 fi
233 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
234 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
235 echo 'quiet::NoStatistic "true";' >> aptconfig.conf
236 # too distracting for users, but helpful to detect changes
237 echo 'Acquire::Progress::Ignore::ShowErrorText "true";' >> aptconfig.conf
238 # in testcases, it can appear as if localhost has a rotation setup,
239 # hide this as we can't really deal with it properly
240 echo 'Acquire::Failure::ShowIP "false";' >> aptconfig.conf
241
242 echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir/etc/apt/apt.conf.d/99https
243 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
244 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
245
246 # cleanup the environment a bit
247 # prefer our apt binaries over the system apt binaries
248 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
249 export LC_ALL=C.UTF-8
250 unset LANGUAGE APT_CONFIG
251 unset GREP_OPTIONS DEB_BUILD_PROFILES
252
253 msgdone "info"
254 }
255
256 getarchitecture() {
257 if [ "$1" = "native" -o -z "$1" ]; then
258 eval `aptconfig shell ARCH APT::Architecture`
259 if [ -n "$ARCH" ]; then
260 echo $ARCH
261 else
262 dpkg --print-architecture
263 fi
264 else
265 echo $1
266 fi
267 }
268
269 getarchitectures() {
270 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
271 }
272
273 getarchitecturesfromcommalist() {
274 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
275 }
276
277 configarchitecture() {
278 {
279 echo "APT::Architecture \"$(getarchitecture $1)\";"
280 while [ -n "$1" ]; do
281 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
282 shift
283 done
284 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
285 configdpkg
286 }
287
288 configdpkg() {
289 if [ ! -e rootdir/var/lib/dpkg/status ]; then
290 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
291 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
292 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
293 else
294 echo -n > rootdir/var/lib/dpkg/status
295 fi
296 fi
297 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
298 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
299 local ARCHS="$(getarchitectures)"
300 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
301 DPKGARCH="$(dpkg --print-architecture)"
302 for ARCH in ${ARCHS}; do
303 if [ "${ARCH}" != "${DPKGARCH}" ]; then
304 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
305 # old-style used e.g. in Ubuntu-P – and as it seems travis
306 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
307 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
308 fi
309 fi
310 done
311 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
312 # dpkg doesn't really check the version as long as it is fully installed,
313 # but just to be sure we choose one above the required version
314 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
315 fi
316 fi
317 fi
318 }
319
320 configcompression() {
321 while [ -n "$1" ]; do
322 case "$1" in
323 '.') printf ".\t.\tcat\n";;
324 'gz') printf "gzip\tgz\tgzip\n";;
325 'bz2') printf "bzip2\tbz2\tbzip2\n";;
326 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
327 'xz') printf "xz\txz\txz\n";;
328 *) printf "$1\t$1\t$1\n";;
329 esac
330 shift
331 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
332 }
333
334 forcecompressor() {
335 COMPRESSOR="$1"
336 COMPRESSOR_CMD="$1"
337 case $COMPRESSOR in
338 gzip) COMPRESS='gz';;
339 bzip2) COMPRESS='bz2';;
340 lzma) COMPRESS='lzma';;
341 xz) COMPRESS='xz';;
342 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
343 esac
344 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
345 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
346 Dir::Bin::uncompressed \"/does/not/exist\";
347 Dir::Bin::gzip \"/does/not/exist\";
348 Dir::Bin::bzip2 \"/does/not/exist\";
349 Dir::Bin::lzma \"/does/not/exist\";
350 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
351 if [ -e "/bin/${COMPRESSOR}" ]; then
352 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
353 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
354 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
355 elif [ "${COMPRESSOR}" = 'lzma' ]; then
356 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
357 COMPRESSOR_CMD='xz --format=lzma'
358 else
359 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
360 msgfail
361 fi
362 }
363
364 setupsimplenativepackage() {
365 local NAME="$1"
366 local ARCH="$2"
367 local VERSION="$3"
368 local RELEASE="${4:-unstable}"
369 local DEPENDENCIES="$5"
370 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
371 If you find such a package installed on your system,
372 something went horribly wrong! They are autogenerated
373 und used only by testcases and surf no other propose…"}"
374
375 local SECTION="${7:-others}"
376 local DISTSECTION
377 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
378 DISTSECTION="main"
379 else
380 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
381 fi
382 local BUILDDIR=incoming/${NAME}-${VERSION}
383 mkdir -p ${BUILDDIR}/debian/source
384 cd ${BUILDDIR}
385 echo "* most suckless software product ever" > FEATURES
386 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
387 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
388
389 * Initial release
390
391 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
392 test -e debian/control || echo "Source: $NAME
393 Section: $SECTION
394 Priority: optional
395 Maintainer: Joe Sixpack <joe@example.org>
396 Build-Depends: debhelper (>= 7)
397 Standards-Version: 3.9.1
398
399 Package: $NAME" > debian/control
400 if [ "$ARCH" = 'all' ]; then
401 echo "Architecture: all" >> debian/control
402 else
403 echo "Architecture: any" >> debian/control
404 fi
405 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
406 echo "Description: $DESCRIPTION" >> debian/control
407
408 test -e debian/compat || echo "7" > debian/compat
409 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
410 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
411 cd - > /dev/null
412 }
413
414 buildsimplenativepackage() {
415 local NAME="$1"
416 local ARCH="$2"
417 local VERSION="$3"
418 local RELEASE="${4:-unstable}"
419 local DEPENDENCIES="$5"
420 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
421 If you find such a package installed on your system,
422 something went horribly wrong! They are autogenerated
423 und used only by testcases and surf no other propose…"}"
424
425 local SECTION="${7:-others}"
426 local PRIORITY="${8:-optional}"
427 local FILE_TREE="$9"
428 local COMPRESS_TYPE="${10:-gzip}"
429 local DISTSECTION
430 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
431 DISTSECTION="main"
432 else
433 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
434 fi
435 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
436
437 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
438 mkdir -p $BUILDDIR/debian/source
439 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
440 echo "#!/bin/sh
441 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
442
443 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
444 echo "$NAME ($VERSION) $RELEASE; urgency=low
445
446 * Initial release
447
448 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
449 echo "Source: $NAME
450 Section: $SECTION
451 Priority: $PRIORITY
452 Maintainer: Joe Sixpack <joe@example.org>
453 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
454 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
455 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
456 echo "
457 Package: $NAME" >> ${BUILDDIR}/debian/control
458
459 if [ "$ARCH" = 'all' ]; then
460 echo "Architecture: all" >> ${BUILDDIR}/debian/control
461 else
462 echo "Architecture: any" >> ${BUILDDIR}/debian/control
463 fi
464 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
465 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
466 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
467
468 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
469 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
470 | while read SRC; do
471 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
472 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
473 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
474 # adv --yes --default-key 'Joe Sixpack' \
475 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
476 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
477 # fi
478 done
479
480 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
481 rm -rf ${BUILDDIR}/debian/tmp
482 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
483 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
484 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
485 if [ -n "$FILE_TREE" ]; then
486 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
487 fi
488
489 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
490 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
491 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
492 # ensure the right permissions as dpkg-deb ensists
493 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
494 if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then
495 cat $LOG
496 false
497 fi
498 rm $LOG
499 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
500 done
501
502 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
503 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
504 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
505 rm -rf "${BUILDDIR}"
506 msgdone "info"
507 }
508
509 buildpackage() {
510 local BUILDDIR=$1
511 local RELEASE=$2
512 local SECTION=$3
513 local ARCH=$(getarchitecture $4)
514 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
515 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
516 msgninfo "Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… "
517 cd $BUILDDIR
518 if [ "$ARCH" = "all" ]; then
519 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
520 fi
521 if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then
522 cat $BUILDLOG
523 false
524 fi
525 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
526 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
527 cd - > /dev/null
528 for PKG in $PKGS; do
529 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
530 done
531 for SRC in $SRCS; do
532 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
533 done
534 msgdone "info"
535 }
536
537 buildaptarchive() {
538 if [ -d incoming ]; then
539 buildaptarchivefromincoming "$@"
540 else
541 buildaptarchivefromfiles "$@"
542 fi
543 }
544
545 createaptftparchiveconfig() {
546 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
547 COMPRESSORS="${COMPRESSORS%* }"
548 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
549 if [ -z "$ARCHS" ]; then
550 # the pool is empty, so we will operate on faked packages - let us use the configured archs
551 ARCHS="$(getarchitectures)"
552 fi
553 echo -n 'Dir {
554 ArchiveDir "' >> ftparchive.conf
555 echo -n $(readlink -f .) >> ftparchive.conf
556 echo -n '";
557 CacheDir "' >> ftparchive.conf
558 echo -n $(readlink -f ..) >> ftparchive.conf
559 echo -n '";
560 FileListDir "' >> ftparchive.conf
561 echo -n $(readlink -f pool/) >> ftparchive.conf
562 echo -n '";
563 };
564 Default {
565 Packages::Compress "'"$COMPRESSORS"'";
566 Sources::Compress "'"$COMPRESSORS"'";
567 Contents::Compress "'"$COMPRESSORS"'";
568 Translation::Compress "'"$COMPRESSORS"'";
569 LongDescription "false";
570 };
571 TreeDefault {
572 Directory "pool/";
573 SrcDirectory "pool/";
574 };
575 APT {
576 FTPArchive {
577 Release {
578 Origin "joesixpack";
579 Label "apttestcases";
580 Suite "unstable";
581 Description "repository with dummy packages";
582 Architectures "' >> ftparchive.conf
583 echo -n "$ARCHS" >> ftparchive.conf
584 echo 'source";
585 };
586 };
587 };' >> ftparchive.conf
588 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
589 echo -n 'tree "dists/' >> ftparchive.conf
590 echo -n "$DIST" >> ftparchive.conf
591 echo -n '" {
592 Architectures "' >> ftparchive.conf
593 echo -n "$ARCHS" >> ftparchive.conf
594 echo -n 'source";
595 FileList "' >> ftparchive.conf
596 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
597 echo -n '";
598 SourceFileList "' >> ftparchive.conf
599 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
600 echo -n '";
601 Sections "' >> ftparchive.conf
602 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
603 echo '";
604 };' >> ftparchive.conf
605 done
606 }
607
608 buildaptftparchivedirectorystructure() {
609 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
610 for DIST in $DISTS; do
611 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
612 for SECTION in $SECTIONS; do
613 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
614 for ARCH in $ARCHS; do
615 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
616 done
617 mkdir -p dists/${DIST}/${SECTION}/source
618 mkdir -p dists/${DIST}/${SECTION}/i18n
619 done
620 done
621 }
622
623 insertpackage() {
624 local RELEASE="$1"
625 local NAME="$2"
626 local ARCH="$3"
627 local VERSION="$4"
628 local DEPENDENCIES="$5"
629 local PRIORITY="${6:-optional}"
630 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
631 If you find such a package installed on your system,
632 something went horribly wrong! They are autogenerated
633 und used only by testcases and surf no other propose…"}"
634 local ARCHS=""
635 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
636 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
637 ARCHS="$(getarchitectures)"
638 else
639 ARCHS="$arch"
640 fi
641 for BUILDARCH in $ARCHS; do
642 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
643 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
644 touch aptarchive/dists/${RELEASE}/main/source/Sources
645 local FILE="${PPATH}/Packages"
646 echo "Package: $NAME
647 Priority: $PRIORITY
648 Section: other
649 Installed-Size: 42
650 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
651 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
652 echo "Version: $VERSION
653 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
654 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
655 echo "Description: $DESCRIPTION" >> $FILE
656 echo >> $FILE
657 done
658 done
659 }
660
661 insertsource() {
662 local RELEASE="$1"
663 local NAME="$2"
664 local ARCH="$3"
665 local VERSION="$4"
666 local DEPENDENCIES="$5"
667 local ARCHS=""
668 local SPATH="aptarchive/dists/${RELEASE}/main/source"
669 mkdir -p $SPATH
670 local FILE="${SPATH}/Sources"
671 echo "Package: $NAME
672 Binary: $NAME
673 Version: $VERSION
674 Maintainer: Joe Sixpack <joe@example.org>
675 Architecture: $ARCH" >> $FILE
676 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
677 echo "Files:
678 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
679 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
680 " >> $FILE
681 }
682
683 insertinstalledpackage() {
684 local NAME="$1"
685 local ARCH="$2"
686 local VERSION="$3"
687 local DEPENDENCIES="$4"
688 local PRIORITY="${5:-optional}"
689 local STATUS="${6:-install ok installed}"
690 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
691 If you find such a package installed on your system,
692 something went horribly wrong! They are autogenerated
693 und used only by testcases and surf no other propose…"}"
694
695 local FILE='rootdir/var/lib/dpkg/status'
696 local INFO='rootdir/var/lib/dpkg/info'
697 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
698 echo "Package: $NAME
699 Status: $STATUS
700 Priority: $PRIORITY
701 Section: other
702 Installed-Size: 42
703 Maintainer: Joe Sixpack <joe@example.org>
704 Version: $VERSION" >> $FILE
705 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
706 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
707 echo "Description: $DESCRIPTION" >> $FILE
708 echo >> $FILE
709 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
710 echo -n > ${INFO}/${NAME}:${arch}.list
711 else
712 echo -n > ${INFO}/${NAME}.list
713 fi
714 done
715 }
716
717
718 buildaptarchivefromincoming() {
719 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
720 cd aptarchive
721 [ -e pool ] || ln -s ../incoming pool
722 [ -e ftparchive.conf ] || createaptftparchiveconfig
723 [ -e dists ] || buildaptftparchivedirectorystructure
724 msgninfo "\tGenerate Packages, Sources and Contents files… "
725 aptftparchive -qq generate ftparchive.conf
726 cd - > /dev/null
727 msgdone "info"
728 generatereleasefiles "$@"
729 }
730
731 buildaptarchivefromfiles() {
732 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
733 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
734 msgninfo "\t${line} file… "
735 compressfile "$line" "$1"
736 msgdone "info"
737 done
738 generatereleasefiles "$@"
739 }
740
741 compressfile() {
742 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
743 if [ "$compressor" = '.' ]; then
744 if [ -n "$2" ]; then
745 touch -d "$2" "$1"
746 fi
747 continue
748 fi
749 cat "$1" | $command > "${1}.${extension}"
750 if [ -n "$2" ]; then
751 touch -d "$2" "${1}.${extension}"
752 fi
753 done
754 }
755
756 # can be overridden by testcases for their pleasure
757 getcodenamefromsuite() {
758 case "$1" in
759 unstable) echo 'sid';;
760 *) echo -n "$1";;
761 esac
762 }
763 getreleaseversionfromsuite() { true; }
764 getlabelfromsuite() { true; }
765
766 generatereleasefiles() {
767 # $1 is the Date header and $2 is the ValidUntil header to be set
768 # both should be given in notation date/touch can understand
769 msgninfo "\tGenerate Release files… "
770 if [ -e aptarchive/dists ]; then
771 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
772 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
773 local CODENAME="$(getcodenamefromsuite $SUITE)"
774 local VERSION="$(getreleaseversionfromsuite $SUITE)"
775 local LABEL="$(getlabelfromsuite $SUITE)"
776 if [ -n "$VERSION" ]; then
777 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
778 fi
779 if [ -n "$LABEL" ]; then
780 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
781 fi
782 aptftparchive -qq release $dir \
783 -o APT::FTPArchive::Release::Suite="${SUITE}" \
784 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
785 ${LABEL} \
786 ${VERSION} \
787 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
788 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
789 sed -i '/^Date: / a\
790 NotAutomatic: yes' $dir/Release
791 fi
792 if [ -n "$1" -a "$1" != "now" ]; then
793 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
794 fi
795 if [ -n "$2" ]; then
796 sed -i "/^Date: / a\
797 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
798 fi
799 done
800 else
801 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
802 fi
803 if [ -n "$1" -a "$1" != "now" ]; then
804 for release in $(find ./aptarchive -name 'Release'); do
805 touch -d "$1" $release
806 done
807 fi
808 msgdone "info"
809 }
810
811 setupdistsaptarchive() {
812 local APTARCHIVE=$(readlink -f ./aptarchive)
813 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
814 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
815 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
816 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
817 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
818 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
819 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
820 msgdone "info"
821 done
822 }
823
824 setupflataptarchive() {
825 local APTARCHIVE=$(readlink -f ./aptarchive)
826 if [ -f ${APTARCHIVE}/Packages ]; then
827 msgninfo "\tadd deb sources.list line… "
828 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
829 msgdone "info"
830 else
831 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
832 fi
833 if [ -f ${APTARCHIVE}/Sources ]; then
834 msgninfo "\tadd deb-src sources.list line… "
835 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
836 msgdone "info"
837 else
838 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
839 fi
840 }
841
842 setupaptarchive() {
843 local NOUPDATE=0
844 if [ "$1" = '--no-update' ]; then
845 NOUPDATE=1
846 shift
847 fi
848 buildaptarchive "$@"
849 if [ -e aptarchive/dists ]; then
850 setupdistsaptarchive
851 else
852 setupflataptarchive
853 fi
854 signreleasefiles 'Joe Sixpack' "$@"
855 if [ "1" != "$NOUPDATE" ]; then
856 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
857 fi
858 }
859
860 signreleasefiles() {
861 local SIGNER="${1:-Joe Sixpack}"
862 local REPODIR="${2:-aptarchive}"
863 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
864 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
865 msgninfo "\tSign archive with $SIGNER key $KEY… "
866 local REXKEY='keys/rexexpired'
867 local SECEXPIREBAK="${REXKEY}.sec.bak"
868 local PUBEXPIREBAK="${REXKEY}.pub.bak"
869 if [ "${SIGNER}" = 'Rex Expired' ]; then
870 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
871 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
872 # therefore we 'temporary' make the key not expired and restore a backup after signing
873 cp ${REXKEY}.sec $SECEXPIREBAK
874 cp ${REXKEY}.pub $PUBEXPIREBAK
875 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
876 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
877 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
878 cp $SECUNEXPIRED ${REXKEY}.sec
879 cp $PUBUNEXPIRED ${REXKEY}.pub
880 else
881 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
882 cat setexpire.gpg
883 exit 1
884 fi
885 cp ${REXKEY}.sec $SECUNEXPIRED
886 cp ${REXKEY}.pub $PUBUNEXPIRED
887 fi
888 fi
889 for RELEASE in $(find ${REPODIR}/ -name Release); do
890 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
891 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
892 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
893 # we might have set a specific date for the Release file, so copy it
894 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
895 done
896 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
897 mv -f $SECEXPIREBAK ${REXKEY}.sec
898 mv -f $PUBEXPIREBAK ${REXKEY}.pub
899 fi
900 msgdone "info"
901 }
902
903 webserverconfig() {
904 msgtest "Set webserver config option '${1}' to" "$2"
905 local DOWNLOG='rootdir/tmp/download-testfile.log'
906 local STATUS='rootdir/tmp/webserverconfig.status'
907 rm -f "$STATUS" "$DOWNLOG"
908 if downloadfile "http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then
909 msgpass
910 else
911 cat "$DOWNLOG" "$STATUS"
912 msgfail
913 fi
914 testwebserverlaststatuscode '200'
915 }
916
917 rewritesourceslist() {
918 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
919 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
920 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
921 done
922 }
923
924 # wait for up to 10s for a pid file to appear to avoid possible race
925 # when a helper is started and dosn't write the PID quick enough
926 waitforpidfile() {
927 local PIDFILE="$1"
928 for i in $(seq 10); do
929 if test -s "$PIDFILE"; then
930 return 0
931 fi
932 sleep 1
933 done
934 msgdie "waiting for $PIDFILE failed"
935 return 1
936 }
937
938 changetowebserver() {
939 if [ "$1" != '--no-rewrite' ]; then
940 rewritesourceslist 'http://localhost:8080/'
941 else
942 shift
943 fi
944 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
945 cd aptarchive
946 local LOG="webserver.log"
947 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
948 cat $LOG
949 false
950 fi
951 waitforpidfile aptwebserver.pid
952 local PID="$(cat aptwebserver.pid)"
953 if [ -z "$PID" ]; then
954 msgdie 'Could not fork aptwebserver successfully'
955 fi
956 addtrap "kill $PID;"
957 cd - > /dev/null
958 else
959 msgdie 'You have to build aptwerbserver or install a webserver'
960 fi
961 }
962
963 changetohttpswebserver() {
964 if ! which stunnel4 >/dev/null; then
965 msgdie 'You need to install stunnel4 for https testcases'
966 fi
967 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
968 changetowebserver --no-rewrite "$@"
969 fi
970 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
971 cert = ${TESTDIRECTORY}/apt.pem
972 output = /dev/null
973
974 [https]
975 accept = 4433
976 connect = 8080
977 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
978 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
979 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
980 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
981 if [ -z "$PID" ]; then
982 msgdie 'Could not fork stunnel4 successfully'
983 fi
984 addtrap 'prefix' "kill ${PID};"
985 rewritesourceslist 'https://localhost:4433/'
986 }
987
988 changetocdrom() {
989 mkdir -p rootdir/media/cdrom/.disk
990 local CD="$(readlink -f rootdir/media/cdrom)"
991 echo "acquire::cdrom::mount \"${CD}\";
992 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
993 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
994 acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
995 echo -n "$1" > ${CD}/.disk/info
996 if [ ! -d aptarchive/dists ]; then
997 msgdie 'Flat file archive cdroms can not be created currently'
998 return 1
999 fi
1000 mv aptarchive/dists "$CD"
1001 ln -s "$(readlink -f ./incoming)" $CD/pool
1002 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1003 # start with an unmounted disk
1004 mv "${CD}" "${CD}-unmounted"
1005 # we don't want the disk to be modifiable
1006 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1007 chmod -R -w rootdir/media/cdrom-unmounted/dists
1008 }
1009
1010 downloadfile() {
1011 local PROTO="$(echo "$1" | cut -d':' -f 1 )"
1012 apthelper -o Debug::Acquire::${PROTO}=1 \
1013 download-file "$1" "$2" 2>&1 || true
1014 # only if the file exists the download was successful
1015 if [ -e "$2" ]; then
1016 return 0
1017 else
1018 return 1
1019 fi
1020 }
1021
1022 checkdiff() {
1023 local DIFFTEXT="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1024 if [ -n "$DIFFTEXT" ]; then
1025 echo >&2
1026 echo >&2 "$DIFFTEXT"
1027 return 1
1028 else
1029 return 0
1030 fi
1031 }
1032
1033 testfileequal() {
1034 local FILE="$1"
1035 shift
1036 msgtest "Test for correctness of file" "$FILE"
1037 if [ -z "$*" ]; then
1038 echo -n "" | checkdiff $FILE - && msgpass || msgfail
1039 else
1040 echo "$*" | checkdiff $FILE - && msgpass || msgfail
1041 fi
1042 }
1043
1044 testempty() {
1045 msgtest "Test for no output of" "$*"
1046 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1047 if $* >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1048 msgpass
1049 else
1050 cat $COMPAREFILE
1051 msgfail
1052 fi
1053 }
1054
1055 testequal() {
1056 local MSG='Test of equality of'
1057 if [ "$1" = '--nomsg' ]; then
1058 MSG=''
1059 shift
1060 fi
1061
1062 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1063 echo "$1" > $COMPAREFILE
1064 shift
1065
1066 if [ -n "$MSG" ]; then
1067 msgtest "$MSG" "$*"
1068 fi
1069 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1070 }
1071
1072 testequalor2() {
1073 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1074 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1075 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1076 echo "$1" > $COMPAREFILE1
1077 echo "$2" > $COMPAREFILE2
1078 shift 2
1079 msgtest "Test for equality OR of" "$*"
1080 $* >$COMPAREAGAINST 2>&1 || true
1081 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1082 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1083 then
1084 msgpass
1085 else
1086 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1087 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1088 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1089 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1090 msgfail
1091 fi
1092 }
1093
1094 testshowvirtual() {
1095 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1096 local PACKAGE="$1"
1097 shift
1098 while [ -n "$1" ]; do
1099 VIRTUAL="${VIRTUAL}
1100 N: Can't select versions from package '$1' as it is purely virtual"
1101 PACKAGE="${PACKAGE} $1"
1102 shift
1103 done
1104 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1105 VIRTUAL="${VIRTUAL}
1106 N: No packages found"
1107 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1108 local ARCH="$(getarchitecture 'native')"
1109 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1110 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1111 }
1112
1113 testnopackage() {
1114 msgtest "Test for non-existent packages" "apt-cache show $*"
1115 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1116 if [ -n "$SHOWPKG" ]; then
1117 echo >&2
1118 echo >&2 "$SHOWPKG"
1119 msgfail
1120 else
1121 msgpass
1122 fi
1123 }
1124
1125 testdpkginstalled() {
1126 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
1127 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
1128 if [ "$PKGS" != $# ]; then
1129 echo >&2 $PKGS
1130 dpkg -l "$@" | grep '^[a-z]' >&2
1131 msgfail
1132 else
1133 msgpass
1134 fi
1135 }
1136
1137 testdpkgnotinstalled() {
1138 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
1139 local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
1140 if [ "$PKGS" != 0 ]; then
1141 echo
1142 dpkg -l "$@" | grep '^[a-z]' >&2
1143 msgfail
1144 else
1145 msgpass
1146 fi
1147 }
1148
1149 testmarkedauto() {
1150 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1151 if [ -n "$1" ]; then
1152 msgtest 'Test for correctly marked as auto-installed' "$*"
1153 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1154 else
1155 msgtest 'Test for correctly marked as auto-installed' 'no package'
1156 echo -n > $COMPAREFILE
1157 fi
1158 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1159 }
1160
1161 testsuccess() {
1162 if [ "$1" = '--nomsg' ]; then
1163 shift
1164 else
1165 msgtest 'Test for successful execution of' "$*"
1166 fi
1167 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1168 if $@ >${OUTPUT} 2>&1; then
1169 msgpass
1170 else
1171 local EXITCODE=$?
1172 echo >&2
1173 cat >&2 $OUTPUT
1174 msgfail "exitcode $EXITCODE"
1175 fi
1176 }
1177
1178 testfailure() {
1179 if [ "$1" = '--nomsg' ]; then
1180 shift
1181 else
1182 msgtest 'Test for failure in execution of' "$*"
1183 fi
1184 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1185 if $@ >${OUTPUT} 2>&1; then
1186 local EXITCODE=$?
1187 echo >&2
1188 cat >&2 $OUTPUT
1189 msgfail "exitcode $EXITCODE"
1190 else
1191 msgpass
1192 fi
1193 }
1194
1195 testaccessrights() {
1196 msgtest "Test that file $1 has access rights set to" "$2"
1197 if [ "$2" = "$(stat --format '%a' "$1")" ]; then
1198 msgpass
1199 else
1200 echo >&2
1201 ls -l >&2 "$1"
1202 echo -n >&2 "stat(1) reports access rights: "
1203 stat --format '%a' "$1"
1204 msgfail
1205 fi
1206 }
1207
1208 testwebserverlaststatuscode() {
1209 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1210 local STATUS='rootdir/tmp/webserverstatus-statusfile.log'
1211 rm -f "$DOWNLOG" "$STATUS"
1212 msgtest 'Test last status code from the webserver was' "$1"
1213 downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG"
1214 if [ "$(cat "$STATUS")" = "$1" ]; then
1215 msgpass
1216 else
1217 echo >&2
1218 if [ -n "$2" ]; then
1219 shift
1220 echo >&2 '#### Additionally provided output files contain:'
1221 cat >&2 "$@"
1222 fi
1223 echo >&2 '#### Download log of the status code:'
1224 cat >&2 "$DOWNLOG"
1225 msgfail "Status was $(cat "$STATUS")"
1226 fi
1227 }
1228
1229 pause() {
1230 echo "STOPPED execution. Press enter to continue"
1231 local IGNORE
1232 read IGNORE
1233 }